-- AI Loader
-- and some utility functions for RO
--


LUA_PATH = "?;?.lua;AI/USER_AI/?.lua;AI/USER_AI/?/?.lua"

require "Try"

-- output message
function log (filename)
	if not filename then return function () end end
	return function (...)
		local msg = ""
		for i, v in ipairs(arg) do
			msg = msg .. "\t" .. string.gsub(tostring(v), "%s", " ")
		end

		local f = io.open(filename, "a")
		try(function ()
			print(msg)
			f:write(
				string.format("%s%s\n", os.date("%Y-%m-%d %H:%M:%S"), msg)
			)
		end).catch(function (e)
			-- nothing to do
		end)
		f:close()
	end
end
d, info = log("Debug.log"), log("Debug.log")


-- Called by RO
function AI (myid)
	try(function ()
		-- load main (defined Main func.) and run it
		Main(myid)
	end).catch(function (e)
		Main = function ()
			info"dofile Main.lua"
			_LOADED = {} -- reset library load
			-- dofile("AI/USER_AI/AIManager.lua")
			dofile("AI/USER_AI/Main.lua")
		end
		if not string.find(e, "attempt to call global `Main'") then
			d("Error: " .. e)
		end
	end)
end


