
require "Class"
require "List"
require "INI"
require "SandBox"

AIManager = Class {
	initialize = function (self)
		self.list = List.new()
		self.sandbox = SandBox.new()

		self.config = INI.new():read("AI/USER_AI/config.ini")
		d(self.config.AI.current)
		self:change(self.config.AI.current)
	end,

	run = function (self, id)
		self.env.AI(id)
	end,

	change = function (self, ai)
		local dir = string.format("AI/USER_AI/%s/", ai)
		self.env = self.sandbox:load(
			dir.."AI.lua",
			dir,
			function (name)
				d(name)
				name = string.gsub(name, "%./", "")
				name = string.gsub(name, "AI/USER_AI/", ai)
				name = string.gsub(name, "AI/", dir)
				return name
			end
		)
	end,
}

function AIManager.run (myid)
	if not AIManager.instance then
		AIManager.instance = AIManager.new()
	end
	AIManager.instance:run(myid)
end

-- reload AI file
function reload ()
	_LOADED = {} -- reset library load
	AIManager.instance = nil
	dofile("AI/USER_AI/AI.lua")
	d"Reloaded"
end

function Main (myid)
	AIManager.run(myid)
end
