
package {
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;

	public class Cell extends Sprite {
		public var cx:uint;
		public var cy:uint;
		public var tooltip:TextField;
		public var _color:uint;
		public var cellSize:uint;
		public var borderColor:uint;
		public var activeColor:uint;
		public function Cell (tx:uint, ty:uint, cs:uint) {
			cx = tx;
			cy = ty;
			cellSize = cs;
			
			x = tx * cellSize;
			y = ty * cellSize;

			addEventListener(Event.ENTER_FRAME, onEnterFrame, false);
			addEventListener(MouseEvent.MOUSE_OVER, onMouseOver, false);
			addEventListener(MouseEvent.MOUSE_OUT,  onMouseOut,  false);
		}

		public function set color (c:uint):void {
			_color = c;
			fill(borderColor, c);
		}

		public function get color ():uint {
			return _color;
		}


		public function fill (bcol:uint, col:uint):void {
			borderColor = bcol;
			var g:Graphics = graphics;
			g.beginFill(bcol)
				g.drawRect(0, 0, cellSize, cellSize);
			g.endFill();
			g.beginFill(col)
				g.drawRect(1, 1, cellSize-2, cellSize-2);
			g.endFill();
			alpha = 0;
		}

		public function onEnterFrame (e:Event):void {
			//field.setObject(0, 0, 0xff0000);
			if (alpha < 1) {
				alpha += 0.2
			} else {
				alpha = 1
			}
		}

		public function onMouseOver (e:Event):void {
			log("over");
			log(e.target);
			log(e.currentTarget);
			if (e.target != e.currentTarget) return;

			fill(borderColor, activeColor);

//			var shadow:DropShadowFilter = new DropShadowFilter(3, 45, 0, 0.6, 5, 5);
//			tooltip.filters = [shadow];
			log(tooltip);
			log(tooltip.parent.numChildren);
			tooltip.visible = true;
			tooltip.parent.setChildIndex(tooltip, tooltip.parent.numChildren-1);
		}

		public function onMouseOut (e:Event):void {
			if (e.target != e.currentTarget) return;

			fill(borderColor, e.target.color);
			tooltip.visible = false;
		}
	}

}
