
// 左下が原点
package {
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import flash.filters.DropShadowFilter;
	import flash.utils.*;

	public class Field extends Sprite {
		public var cells:Array = [];
		public var cellSize:int;
		public var borderColor:uint;
		public var fillColor:uint;
		public var activeColor:uint;
		public var mobs:Object = {};
		public var center:Array = [0, 0];

		[Embed(
			systemFont = "Arial",
			fontName   = "Arial",
			mimeType   = 'application/x-font',
			flashType  = 'true'
		)]
		public var FontArial:Class;

		public function Field (size:int, bc:uint=0x222222, fc:uint=0x000000, ac:uint=0x990000) {
			cellSize    = size;
			borderColor = bc;
			fillColor   = fc;
			activeColor = ac;

			var tf:TextFormat = new TextFormat();
			tf.size = 14;
			tf.font = "Arial";

			for (var i:int = 0; i < 21; i++) {
				cells[i] = [];
				for (var j:int = 0; j < 21; j++) {
					var s:Cell = new Cell(i, j, cellSize);
					s.color = fillColor;
					s.activeColor = activeColor;

					s.fill(borderColor, fillColor);

					var tooltip:TextField = new TextField();
					tooltip.embedFonts = true;
					tooltip.autoSize = TextFieldAutoSize.CENTER;
					tooltip.defaultTextFormat = tf;
					tooltip.textColor = 0xffffff;
					tooltip.text = "["+(i-10)+", "+(20-j-10)+"]";
					tooltip.x = (i + 1) * cellSize;
					tooltip.y = (j + 1) * cellSize;
					tooltip.visible = false;
					addChild(tooltip);
					s.tooltip = tooltip;

					addChild(s);
					cells[i][j] = s;
				}
			}

//			setInterval(function ():void {
//				var f:Function = function ():int {
//					return Math.floor(Math.random() * 21);
//				}
//				var mob:Mob = new Mob(f(), f(), cellSize);
//				addChild(mob);
//				mob.fill(borderColor, 0x990000);
//				mob.moveTo(f(), f());
//			}, 100);
		}

		public function addMob(id:int, x:int, y:int, tp:String, col:uint):void {
			var mob:Mob = new Mob(x - center[0] + 10, 10 - (y - center[1]), cellSize);
			addChild(mob);
			mob.fill(borderColor, col);
			mob.tooltip.text = String(tp);
			mobs[id] = mob;
		}

		public function removeMob(id:int):void {
			removeChild(mobs[id]);
			delete mobs[id];
		}

		public function moveMob(id:int, tox:int, toy:int):void {
			log(tox, toy, center);
			var m:Mob =  mobs[id];
			m.moveTo(tox - center[0] + 10, 10 - (toy - center[1]));
		}
	}
}
