
package {
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import flash.utils.Timer;

	public class Mob extends Sprite {
		public var cx:uint;
		public var cy:uint;
		public var tooltip:TextField;
		public var _color:uint;
		public var cellSize:uint;
		public var borderColor:uint;
		public var activeColor:uint;
		private var targetX:int;
		private var targetY:int;
		private var deltaX:Number;
		private var deltaY:Number;
		private var t:Timer;

		[Embed(
			systemFont = "Arial",
			fontName   = "Arial",
			mimeType   = 'application/x-font',
			flashType  = 'true'
		)]
		public var FontArial:Class;

		public function Mob (tx:uint, ty:uint, cs:uint) {
			cx = tx;
			cy = ty;
			cellSize = cs;
			
			x = tx * cellSize;
			y = ty * cellSize;

			var tf:TextFormat = new TextFormat();
			tf.size = 14;
			tf.font = "Arial";
			tooltip = new TextField();
			tooltip.embedFonts = true;
			tooltip.autoSize = TextFieldAutoSize.CENTER;
			tooltip.defaultTextFormat = tf;
			tooltip.textColor = 0xffffff;
			tooltip.text = "Unknown Mob.";
			tooltip.x = cellSize / 2;
			tooltip.y = cellSize;
			tooltip.visible = false;
			addChild(tooltip);

			addEventListener(MouseEvent.MOUSE_OVER, onMouseOver, false);
			addEventListener(MouseEvent.MOUSE_OUT,  onMouseOut,  false);
		}

		public function set color (c:uint):void {
			_color = c;
			fill(borderColor, c);
		}

		public function get color ():uint {
			return _color;
		}


		public function fill (bcol:uint, col:uint):void {
			log(color, borderColor);
			_color = col;
			borderColor = bcol;
			var g:Graphics = graphics;
			g.beginFill(bcol)
				g.drawRect(0, 0, cellSize, cellSize);
			g.endFill();
			g.beginFill(col)
				g.drawRect(1, 1, cellSize-2, cellSize-2);
			g.endFill();
		}

		public function moveTo (tx:uint, ty:uint):void {
			log([tx, ty].join(","));
			targetX = tx * cellSize;
			targetY = ty * cellSize;
			var m:int = Math.abs(tx > ty ? targetX - x : targetY - y);
			if (!m) return;
			deltaX  = (targetX - x) / m;
			deltaY  = (targetY - y) / m;
			if (t) t.stop();
			t = new Timer(24, m);
			t.addEventListener(TimerEvent.TIMER, function (e:Event):void {
				x += deltaX;
				y += deltaY;
			}, false);
			t.addEventListener(TimerEvent.TIMER_COMPLETE, function (e:Event):void {
				x = targetX;
				y = targetY;
			}, false);
			t.start();
		}

		public function onMouseOver (e:Event):void {
			if (e.target != e.currentTarget) return;
			tooltip.visible = true;
			parent.setChildIndex(this, parent.numChildren-1);
		}

		public function onMouseOut (e:Event):void {
			if (e.target != e.currentTarget) return;
			tooltip.visible = false;
		}

		public function die ():void {
			var self:* = this;
			var t:Timer = new Timer(48, 20);
			t.addEventListener(TimerEvent.TIMER, function (e:Event):void {
				alpha = alpha ? 0 : 1;
			}, false);
			t.addEventListener(TimerEvent.TIMER_COMPLETE, function (e:Event):void {
				parent.removeChild(self);
			}, false);
			t.start();
		}
	}

}
