--[[
Constants
]]


-- Copy from Const.lua and script manual {{{

V_OWNER                   = 0      -- 召喚者の ID
V_POSITION                = 1      -- 座標 (x、y)
V_TYPE                    = 2      -- タイプ (未実装)
V_MOTION                  = 3      -- 現在の命令
V_ATTACKRANGE             = 4      -- 物理攻撃範囲 (未実装。現在は1セルに固定)
V_TARGET                  = 5      -- 攻撃、スキル使用対象の ID
V_SKILLATTACKRANGE        = 6      -- スキル攻撃範囲 (未実装)
V_HOMUNTYPE               = 7      -- ホムンクルスの種類
V_HP                      = 8      -- HP (ホムンクルスと召喚者)
V_SP                      = 9      -- SP (ホムンクルスと召喚者)
V_MAXHP                   = 10     -- 最大 HP (ホムンクルスと召喚者)
V_MAXSP                   = 11     -- 最大 SP (ホムンクルスと召喚者)

LIF                       = 1 -- リーフ
AMISTR                    = 2 -- アミストル
FILIR                     = 3 -- フィーリル
VANILMIRTH                = 4 -- バニルミルト
LIF2                      = 5 -- リーフ2
AMISTR2                   = 6 -- アミストル2
FILIR2                    = 7 -- フィーリル2
VANILMIRTH2               = 8 -- バニルミルト2
LIF_H                     = 9 -- 進化したリーフ
AMISTR_H                  = 10 -- 進化したアミストル
FILIR_H                   = 11 -- 進化したフィーリル
VANILMIRTH_H              = 12 -- 進化したバニルミルト
LIF_H2                    = 13 -- 進化したリーフ2
AMISTR_H2                 = 14 -- 進化したアミストル2
FILIR_H2                  = 15 -- 進化したフィーリル2
VANILMIRTH_H2             = 16 -- 進化したバニルミルト2

MOTION_STAND              = 0 -- 立っている
MOTION_MOVE               = 1 -- 移動中
MOTION_ATTACK             = 2 -- 攻撃中
MOTION_DEAD               = 3 -- 死んで倒れる
MOTION_DAMAGE             = 4 -- ダメージを受けた時
MOTION_BENDDOWN           = 5 -- かがむ（アイテムを拾う、罠を置く）
MOTION_SIT                = 6 -- 座っている
MOTION_SKILL              = 7 -- スキル攻撃中（インベ、カートレボリューション、ラウドボイス）
MOTION_CASTING            = 8 -- 詠唱
MOTION_ATTACK2            = 9 -- 攻撃
MOTION_SPIRAL             = 11 -- スパイラルピアース
MOTION_TOSS               = 12 -- 投げる（スピアブーメラン、ポーションピッチャー、バイオプラント）
MOTION_COUNTER            = 13 -- オートカウンター
MOTION_PERFORM            = 17 -- 演奏
MOTION_UPPER              = 19 -- ノピティギ上昇中
MOTION_DOWNER             = 20 -- ノピティギ下降中
MOTION_SOUL               = 23 -- ソウルリンカー、魂使用
MOTION_IN                 = 25 -- ノピティギ着地、落法
MOTION_BIGTOSS            = 28 -- 大きく投げる（スリムポーションピッチャー、アシッドデモンストレーション）
MOTION_DESPERADO          = 38 -- デスペラード
MOTION_XXXXXX             = 39 -- 不明（コインフィリップ/ダスト？）
MOTION_FULLBASTERD        = 42 -- フルバスター


NONE_CMD                  = 0
MOVE_CMD                  = 1 -- {コマンド番号、X座標、Y座標}
STOP_CMD                  = 2 -- {コマンド番号}
ATTACK_OBJECT_CMD         = 3 -- {コマンド番号、目標ID}
ATTACK_AREA_CMD           = 4 -- {コマンド番号、X座標、Y座標}
PATROL_CMD                = 5 -- {コマンド番号、X座標、Y座標}
HOLD_CMD                  = 6 -- {コマンド番号}
SKILL_OBJECT_CMD          = 7 -- {コマンド番号、選択レベル、種類、目標ID}
SKILL_AREA_CMD            = 8 -- {コマンド番号、選択レベル、種類、X座標、Y座標}
FOLLOW_CMD                = 9 -- {コマンド番号}

COMMAND = {
	[0] = "NONE_CMD",
	[1] = "MOVE_CMD",
	[2] = "STOP_CMD",
	[3] = "ATTACK_OBJECT_CMD",
	[4] = "ATTACK_AREA_CMD",
	[5] = "PATROL_CMD",
	[6] = "HOLD_CMD",
	[7] = "SKILL_OBJECT_CMD",
	[8] = "SKILL_AREA_CMD",
	[9] = "FOLLOW_CMD",
}

-- Skill ID
-- リーフ
SKILL_TOUCH_OF_HEAL       = 8001 -- 治癒の手
SKILL_EMERGENCY_AVOID     = 8002 -- 緊急回避
SKILL_BRAIN_SURGERY       = 8003 -- 脳手術
SKILL_MENTAL_CHANGE       = 8004 -- メンタルチェンジ

-- アミストル
SKILL_CASTLING            = 8005 -- キャスリング
SKILL_DEFENCE             = 8006 -- ディフェンス
SKILL_ADAMANTIUM_SKIN     = 8007 -- アダマンティウムスキン
SKILL_BLOOD_LUST          = 8008 -- ブラッドラスト

-- フィーリル
SKILL_MOONLIGHT           = 8009 -- ムーンライト
SKILL_FLEET_MOVE          = 8010 -- フリットムーブ
SKILL_OVERED_SPEED        = 8011 -- オーバードスピード
SKILL_SBR44               = 8012 -- S.B.R.44

-- バニルミルト
SKILL_CAPRICE             = 8013 -- カプリス
SKILL_CHAOTIC_VENEDICTION = 8014 -- カオティックベネディクション
SKILL_CHANGE_INSTRUCTION  = 8015 -- チェンジインストラクション
SKILL_BIO_EXPLOSION       = 8016 -- バイオエクスプロージョン

-- }}}
--


